<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Plugins
 */
/**************************************************************************/

class Valutes_Admin extends A_MainFrame
{
  function __construct()
  {
    parent::__construct("plugin_valutes.tpl");

	$this->AddJScript("/plugins/valutes/admin/valutes.js");
  }

  function Action($action)
  {
    $res=false;
    switch($action)
    { case "add": $res=$this->Add(); break;
	  case "edit": $res=$this->Edit(); break;
	  case "del": $res=$this->Del(); break;
	  case "addcat": $res=$this->AddCat(); break;
	  case "editcat": $res=$this->EditCat(); break;
	  case "delcat": $res=$this->DelCat(); break;
	  case "update": $res=$this->Update(); break;
	}
    if($res)
	A::goUrl("admin.php?mode=structures&item=".ITEM,array('idv','tab'));
  }

  function Add()
  {
	$_REQUEST['name']=preg_replace("/[^a-zA-Z0-9_-]/i","",$_REQUEST['name']);
	$_REQUEST['caption']=strip_tags(trim($_REQUEST['caption']));
	$_REQUEST['sort']=A::$DB->getOne("SELECT MAX(sort) FROM ".STRUCTURE)+1;
	$_REQUEST['kurs']=(float)$_REQUEST['kurs'];

	if(empty($_REQUEST['name']) || A::$DB->existsRow("SELECT id FROM ".STRUCTURE." WHERE name=?",$_REQUEST['name']))
	{ $this->errors['doublevalute']=true;
	  return false;
	}

    $dataset = new A_DataSet(STRUCTURE);
    $dataset->fields=array("name","caption","kurs","sort");
    return $dataset->Insert();
  }

  function Edit()
  {
	$_REQUEST['name']=preg_replace("/[^a-zA-Z0-9_-]/i","",$_REQUEST['name']);
	$_REQUEST['caption']=strip_tags(trim($_REQUEST['caption']));
	$_REQUEST['kurs']=(float)$_REQUEST['kurs'];

	if(empty($_REQUEST['name']) || A::$DB->existsRow("SELECT id FROM ".STRUCTURE." WHERE name=? AND id<>".(integer)$_REQUEST['id'],$_REQUEST['name']))
	{ $this->errors['doublevalute']=true;
	  return false;
	}

    $dataset = new A_DataSet(STRUCTURE);
    $dataset->fields=array("name","caption","kurs");
    return $dataset->Update();
  }

  function Del()
  {
    $dataset = new A_DataSet(STRUCTURE);
    return $dataset->Delete();
  }

  function AddCat()
  {
	if($idcat=(integer)$_REQUEST['idcat'])
	{ if(!empty($_REQUEST['id']))
	  foreach($_REQUEST['id'] as $id)
	  if($valute=A::$DB->getRowById($id,STRUCTURE))
	  { $data=!empty($valute['data'])?unserialize($valute['data']):array();
	    $kurs=!empty($_REQUEST['kurs_'.$valute['name']])?(float)$_REQUEST['kurs_'.$valute['name']]:0;
	    $per=!empty($_REQUEST['per_'.$valute['name']])?(float)$_REQUEST['per_'.$valute['name']]:0;
		$data[$idcat]=array('kurs'=>$kurs,'per'=>$per);
	    A::$DB->Update(STRUCTURE,array('data'=>serialize($data)),"id=".$valute['id']);
	  }
      return true;
	}
	else
	return false;
  }

  function EditCat()
  {
    if($idcat=(integer)$_REQUEST['idcat'])
	{ if(!empty($_REQUEST['id']))
	  foreach($_REQUEST['id'] as $id)
	  if($valute=A::$DB->getRowById($id,STRUCTURE))
	  { $data=!empty($valute['data'])?unserialize($valute['data']):array();
	    if(isset($data[$_REQUEST['previdcat']]))
	    unset($data[$_REQUEST['previdcat']]);
	    $kurs=!empty($_REQUEST['kurs_'.$valute['name']])?(float)$_REQUEST['kurs_'.$valute['name']]:0;
	    $per=!empty($_REQUEST['per_'.$valute['name']])?(float)$_REQUEST['per_'.$valute['name']]:0;
		$data[$idcat]=array('kurs'=>$kurs,'per'=>$per);
	    A::$DB->Update(STRUCTURE,array('data'=>serialize($data)),"id=".$valute['id']);
	  }
      return true;
	}
	else
	return false;
  }

  function DelCat()
  {
    $ids=!empty($_REQUEST['id'])?array((integer)$_REQUEST['id']):A::$DB->getCol("SELECT id FROM ".STRUCTURE);
    foreach($ids as $id)
	if($valute=A::$DB->getRowById($id,STRUCTURE))
	{ $data=!empty($valute['data'])?unserialize($valute['data']):array();
	  if(isset($data[$_REQUEST['idcat']]))
	  unset($data[$_REQUEST['idcat']]);
	  A::$DB->Update(STRUCTURE,array('data'=>serialize($data)),"id=".$valute['id']);
	}
    $_GET['idv']=$_REQUEST['id'];
	return true;
  }

  function Update()
  {
    if($base=A::$DB->getOne("SELECT name FROM ".STRUCTURE." WHERE kurs=1"))
    {
      if(extension_loaded('curl'))
      {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL,"http://www.cbr.ru/scripts/XML_daily.asp");
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_USERAGENT, 'A.CMS');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $xml = curl_exec($ch);
        curl_close($ch);

        if(!$xml)
        return false;

        require_once 'XML/Unserializer.php';

        $unserializer = new XML_Unserializer();
        $unserializer->unserialize(mb_convert_encoding($xml,"UTF-8","Windows-1251"));

        if($xml=$unserializer->getUnserializedData())
        {
	      $valutes=array('rur'=>1);
          if(!empty($xml['Valute']))
          foreach($xml['Valute'] as $data)
          $valutes[strtolower($data['CharCode'])]=((float)str_replace(",",".",$data['Value']))/$data['Nominal'];

	      $base=strtolower($base);

	      if($val=!empty($valutes[$base])?$valutes[$base]:0)
	      { foreach($valutes as $id=>$value)
            $valutes[$id]=$value?$val/$value:0;

		    A::$DB->query("SELECT id,name,data FROM ".STRUCTURE." WHERE kurs<>1");
		    while($row=A::$DB->fetchRow())
		    if(isset($valutes[$id=strtolower($row['name'])]))
		    { $data=!empty($row['data'])?unserialize($row['data']):array();
		      foreach($data as $idcat=>$vdata)
		      $data[$idcat]['kurs']=round($valutes[$id],4);
		      A::$DB->Update(STRUCTURE,array('kurs'=>round($valutes[$id],4),'data'=>!empty($data)?serialize($data):""),"id=".$row['id']);
		    }
		    A::$DB->free();
		    return true;
          }
        }
      }
    }
    else
    $this->errors['nobase']=true;
	return false;
  }

  function createData()
  {
	$this->Assign("shopassoc",$section=getSectionByModule('shoplite'));

	if(empty($section)) return;

	$this->Assign("shopvalute",getOption($section,'valute'));
	$this->Assign("usecurl",extension_loaded('curl'));

	$valutes=array();
	$cats=array();
  	A::$DB->query("SELECT * FROM ".STRUCTURE." ORDER BY sort");
	while($row=A::$DB->fetchRow())
	{ if(empty($_GET['idv']))
	  { $data=!empty($row['data'])?unserialize($row['data']):array();
	    foreach($data as $idcat=>$_data)
	    { $_data['name']=getTreePath($section."_categories",$idcat);
		  $cats[$idcat]=$_data;
	    }
	  }
	  $valutes[]=$row;
	}
	A::$DB->free();
	$this->Assign("valutes",$valutes);

	if(!empty($_GET['idv']))
	{ if($valute=A::$DB->getRowById($_GET['idv'],STRUCTURE))
      { $this->Assign("valute",$valute);
        $data=!empty($valute['data'])?unserialize($valute['data']):array();
        foreach($data as $idcat=>$_data)
	    { $_data['name']=getTreePath($section."_categories",$idcat);
		  $cats[$idcat]=$_data;
	    }
      }
	}

	$this->Assign("cats",$cats);
  }
}

A::$MAINFRAME = new Valutes_Admin;